



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Go-For Range 性能研究</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Go-For Range 性能研究</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 23:23:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong> 文章转载地址：https://www.flysnow.org/2018/10/20/golang-for-range-slice-map.html</strong></p>
<p>如果我们要遍历某个数组，Map 集合、Slice 切片等，Go 语言(Golang) 为我们提供了比较好的 For Range 方式。</p>
<p>range 是一个关键字， 表示范围，和 for 配合使用可以迭代 数组、Map、Slice等集合，用法比较简洁，那么，这种</p>
<p>迭代方式和 for i=0;i&lt;N;i++ 对比，性能怎么样呢？下面通过 Go 的基准测试对比一下两者的性能</p>
<p><strong>For-Range 的基本使用</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp;</strong> for range 的使用非常简单，这里演示两种集合类型的使用</p>
<div>
<pre class="prettyprint linenums">package main

import "fmt"

func main() {<br />
	ages := []string{"10","20","30"}

	for i,age := range ages {<br />
		fmt.Println(i,age)<br />
	}<br />
}
</pre>
</div>
<p>　　这里是针对 Slice 切片的迭代使用，使用 range 关键字返回两个变量 i,age ，第一个是 Slice 切片的索引，第二个</p>
<p>是 Slice 切片的内容，打印结果如下：</p>
<div>
<pre class="prettyprint linenums">0 10<br />
1 20<br />
2 30
</pre>
</div>
<p>　　下面再看看 Map 的 for range 使用示例：</p>
<div>
<pre class="prettyprint linenums">package main

import "fmt"

func main() {<br />
	ages:=map[string]int{"张三":15,"李四":20,"王武":36}

	for name,age:=range ages{<br />
		fmt.Println(name,age)<br />
	}<br />
}
</pre>
</div>
<p>　　在使用for range迭代map的时候，返回的第一个变量是key,第二个变量是value，也就是我们例子中对应的name和ages</p>
<p>。我们运行程序看看输出结果：</p>
<div>
<pre class="prettyprint linenums">张三 15<br />
李四 20<br />
王五 36
</pre>
</div>
<p>　　<strong>常规 For 循环对比</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; &nbsp;</strong>比如对于 Slice 切片，我们有两种迭代方式：一种是常规的for i:=0;i&lt;N;i++的方式；一种是for range的方式，如下示例：</p>
<div>
<pre class="prettyprint linenums">package main_test

import "testing"

const N  = 1000

// 常规 for 迭代 slice<br />
func ForSlice(s []string) {<br />
	len := len(s)<br />
	for i := 0; i &lt; len; i++ {<br />
		_, _ = i,s[i]<br />
	}<br />
}

// for range 迭代 slice<br />
func RangeForSlice(s []string) {<br />
	for i, v := range s {<br />
		_, _ = i, v<br />
	}<br />
}

// 初始化 slice<br />
func initSlice() []string{<br />
	s := make([]string,N)

	for i := 0;i &lt; N;i++ {<br />
		s[i] = "www.flysnow.org"<br />
	}<br />
	return s<br />
}

// 基准测试函数<br />
func BenchmarkForSlice(b *testing.B) {<br />
	s := initSlice()

	b.ResetTimer()<br />
	for i := 0;i &lt; b.N;i++ {<br />
		ForSlice(s)<br />
	}<br />
}

func BenchmarkRangeForSlice(b *testing.B) {<br />
	s := initSlice()

	b.ResetTimer()<br />
	for i := 0;i &lt; b.N;i++  {<br />
		RangeForSlice(s)<br />
	}<br />
}
</pre>
</div>
<p>　　输出结果如下：</p>
<div>
<pre class="prettyprint linenums">goos: windows<br />
goarch: amd64<br />
BenchmarkForSlice-8              5000000               303 ns/op<br />
BenchmarkRangeForSlice-8         3000000               512 ns/op<br />
PASS<br />
ok      _/E_/GoProject/development/src  4.692s
</pre>
</div>
<p>　　从上面的输出结果可以看到，常规的 For 循环的性能更高。主要是因为 for range 是每次对循环元素的拷贝，而</p>
<p>for 循环，它获取集合内元素是通过 s[i]，这种索引指针引用的方式，要比拷贝性能高得多</p>
<p>那么既然是元素拷贝的问题，我们在使用 range 方式迭代 slice 时候的目的也是为了获取元素，现在换一种方式实现 for range：</p>
<div>
<pre class="prettyprint linenums">// for range 迭代 slice<br />
func RangeForSlice(s []string) {<br />
	for i, _ := range s {<br />
		_, _ = i, s[i]<br />
	}<br />
}
</pre>
</div>
<p>　　输出结果：</p>
<div>
<pre class="prettyprint linenums">goos: windows<br />
goarch: amd64<br />
BenchmarkForSlice-8              5000000               303 ns/op<br />
BenchmarkRangeForSlice-8         5000000               308 ns/op<br />
PASS<br />
ok      _/E_/GoProject/development/src  4.218s
</pre>
</div>
<p>　　结果和常规的 for 循环一样。原因是我们通过 _ 舍弃了元素的复制，然后通过 s[i] 方式获取迭代的元素</p>
<p><strong>Map 遍历</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; &nbsp;</strong>对于 map 来说，我们并不能使用 for i=0;i&lt;N;i++ 的方式，大部分我们使用 for range 的方式：</p>
<div>
<pre class="prettyprint linenums">package main_test

import (<br />
	"fmt"<br />
	"testing"<br />
)

const N  = 1000

// for range For map<br />
func RangeForMap1(m map[int]string) {<br />
	for k, v := range m{<br />
		_,_ = k,v<br />
	}<br />
}

// 初始化 map<br />
func initMap() map[int]string  {<br />
	m := make(map[int]string,N)

	for i := 0;i &lt; N;i++ {<br />
		m[i] = fmt.Sprint("www.flysnow.org",i)<br />
	}

	return m<br />
}

func BenchmarkRangeForMap1(b *testing.B) {<br />
	m := initMap()

	b.ResetTimer()<br />
	for i := 0; i &lt; b.N; i++ {<br />
		RangeForMap1(m)<br />
	}<br />
}
</pre>
</div>
<p>　　运行结果如下：</p>
<div>
<pre class="prettyprint linenums">goos: windows<br />
goarch: amd64<br />
BenchmarkRangeForMap1-8           100000             14535 ns/op<br />
PASS<br />
ok      _/E_/GoProject/development/src  2.333s
</pre>
</div>
<p>　　相比较 slice，Map 遍历的性能更差。现在，我们使用上面优化遍历 slice 的方式优化遍历 map，减少值拷贝，如下示例：</p>
<div>
<pre class="prettyprint linenums">func RangeForMap2(m map[int]string) {<br />
	for k, _ := range m{<br />
		_,_ = k,m[k]<br />
	}<br />
}

func BenchmarkRangeForMap2(b *testing.B) {<br />
	m := initMap()

	b.ResetTimer()<br />
	for i := 0; i &lt; b.N; i++ {<br />
		RangeForMap2(m)<br />
	}<br />
}
</pre>
</div>
<p>　　运行结果如下：</p>
<div>
<pre class="prettyprint linenums">goos: windows<br />
goarch: amd64<br />
BenchmarkRangeForMap1-8           100000             14290 ns/op<br />
BenchmarkRangeForMap2-8           100000             22240 ns/op<br />
PASS<br />
ok      _/E_/GoProject/development/src  4.929s
</pre>
</div>
<p>　　我们看到，优化后的结果性能明显下降了，这和我们上面测试 slice 不一样，这次没有提升反而下降了</p>
<p><strong>For Range 原理</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; &nbsp; </strong>range for slice：</p>
<div>
<pre class="prettyprint linenums">  // The loop we generate:<br />
  //   len_temp := len(range)<br />
  //   range_temp := range<br />
  //   for index_temp = 0; index_temp &lt; len_temp; index_temp++ {<br />
  //           value_temp = range_temp[index_temp]<br />
  //           index = index_temp<br />
  //           value = value_temp<br />
  //           original body<br />
  //   }
</pre>
</div>
<p>　　遍历 slice 前先是对要遍历的 slice 做一个拷贝，然后获取 slice 的长度作为循环次数，循环体中每次循环</p>
<p>会先获取元素值，我们还可以看到遍历过程中每次迭代都会对 index 和 value 进行赋值，如果数据量比较大或</p>
<p>者 value 为 string 时，对 value 的赋值操作可能是多余的，所以在上面我们使用 range 遍历 slice 的时候，可以</p>
<p>忽略 value，使用 slice[index] 的方式提升性能</p>
<p>range for map：</p>
<div>
<pre class="prettyprint linenums">// The loop we generate:<br />
  //   var hiter map_iteration_struct<br />
  //   for mapiterinit(type, range, &amp;hiter); hiter.key != nil; mapiternext(&amp;hiter) {<br />
  //           index_temp = *hiter.key<br />
  //           value_temp = *hiter.val<br />
  //           index = index_temp<br />
  //           value = value_temp<br />
  //           original body<br />
  //   }
</pre>
</div>
<p>　　看上面的实现方式，结合我们使用 for range slice 的 _ 优化方式，我们可以看到看似减少了一次赋值操作，但</p>
<p>是通过 key 查找 value 的性能消耗高于赋值消耗，这就是为什么优化没有起到作用</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e46nz9.html">IntelliJ IDEA上创建maven Spring MVC项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3j4x8.html">JQuery对ASP&period;NET MVC数据进行更新删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wryvq.html">黑马程序员&mdash;&mdash;JAVA基础之反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnpzxx8.html">tomcat支持多少并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7lmk9.html">使用Eclipse调试Android Native Application－－－cocos2d-x ＋ Eclipse &plus; Android &plus; ndk</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv6761q.html">C&plus;&plus;中的初始化列表中可以对那些变量或对象进行初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdy5y8.html">ExtJS4&period;2学习&lpar;7&rpar;&mdash;&mdash;基础知识之Reader&amp;amp&semi;Writer篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1r301q.html">Neo4j 第二篇：图形数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4egdx9.html">chrome 无头浏览器的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv27lyz9.html">SQL Server2008 4064错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g1jovq.html">ie9 form submit 请求参数问题替代办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdmmnz9.html">shell脚本一键安装nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgv1z8.html">【BZOJ】1085&colon; &lbrack;SCOI2005&rsqb;骑士精神</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgz0kq.html">fedora 安装gdal</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jeyonq.html">本地主机不安装oracle客户端--访问远程oracle数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk1g39.html">&lbrack;Delphi&rsqb;实现使用TIdHttp控件向https地址Post请求&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2dxjj8.html">Unable to convert MySQL date&sol;time value to System&period;DateTime</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppw5xk9.html">springboot 多环境配置yml或properties</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gppljz9.html">2 go语言的基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komkdjq.html">Android 框架</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnjrl4k8.html">转载：Android RecyclerView 使用完全解析 体验艺术般的控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp3d639.html">python练习题-day17</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp6100q.html">python3&period;6安装docx模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1gm7yq.html">java生成条形码工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kg3r09.html">判断文件的编码 python</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meo0vpq.html">linux 基本原则和常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljz6d09.html">【kafka学习之六】kakfa消息生产、消费示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meo15rq.html">Linux Maven安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1em4gq.html">20175208 张家华 MyCP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp3yz69.html">java 几个实用的小工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
